from __future__ import unicode_literals


from scipy import signal
import matplotlib.pyplot as plt
import numpy as np
import datetime
from obspy.core import read
import obspy
from obspy import *
from obspy.core import utcdatetime
#from obspy.signal import bandpass
#from numpy import mean, sqrt, square, arange
import operator
import sys
from obspy.signal.trigger import classic_sta_lta
from obspy.signal.trigger import carl_sta_trig
import pylab
import copy
from scipy import signal
import os
import time
import math
from scipy import integrate
from obspy import read
#import plotly.plotly as py
#import plotly.graph_objs as go


from obspy.signal.trigger import classic_sta_lta, plot_trigger
#intanto vado a leggere la traccia in SAC
from math import*



# creating I order, 10 Hz, low pass Butterworth filter
fc = 10 # [Hz]
wc = 2*np.pi*fc # [rad/s]
b, a = signal.butter(1, wc, 'low', analog=True)	# mi ritorna un sistema Num(s)/Den(s)
num=b
den=a

w, h = signal.freqs(b, a)	# ideal frequency response of filter
w = 0.5*w/np.pi				# [rad/s] to [Hz]
amp=20*np.log10(np.abs(h))	# amplitude to dB

'''
# ideal filter frequency response dB vs Hz
plt.plot(w, amp)
plt.xscale('log')
plt.grid()
plt.xlabel("Frequency [Hz]")
plt.ylabel("Amplitude [dB]")
plt.show()
'''



system=signal.lti(num, den)
t, impulse_resp = signal.impulse(system)
impulse_resp = impulse_resp[1:] 	# removing first element due it's always 0.0
t = t[1:]

print("Risposta impulsiva:")		# filter impulse response (kernel of filter in time domain)
print(impulse_resp)

# normalizing kernel to 1.0
kernel=len(impulse_resp)
impulse_resp=impulse_resp /sum(impulse_resp)	# vado a normalizzare il kernel per il filtro
print(sum(impulse_resp))

# now I can use impulse response as kernel in time domain






# let's make some noise
mu, sigma = 0, 0.1
sample = 100000			# 100k samples
Fs=1000					# [SPS] sampling frequency
x = np.arange(sample)
noise = np.random.normal(mu, sigma, len(x))  # noise

# time domain to frequency domain (noise)
#f, psd = signal.periodogram(noise, Fs)
f, psd = signal.welch(noise, Fs, scaling='spectrum')

# removing first element due related to 0 Hz (for log scale)
f=f[1:]
psd=psd[1:]


# filtering in time domain using convolution and filter impulse response
filtrato=np.convolve(noise, impulse_resp)	# filtering noise
filtrato=filtrato[:len(filtrato)-len(impulse_resp)+1]	# equalizing length due to kernel dimension

# time domain to frequency domain for filtered noise
#f, psd2 = signal.periodogram(filtrato, Fs)
f, psd2 = signal.welch(filtrato, Fs, scaling='spectrum')

# as above
f=f[1:]
psd2=psd2[1:]



# ratio filtered/unfiltered signal
legenda=[]
tf=psd2/psd
plt.plot(f,20*np.log10(tf))
legenda.append("real")
plt.plot(w, amp)
legenda.append("ideal")
plt.xscale('log')
plt.xlabel('Frequency [Hz]')
plt.ylabel('Attenuation [dB]')
plt.legend(legenda)
plt.grid()
plt.show()
